﻿package  {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.GlowFilter;
	import flash.geom.Matrix;
	
	public class DrawTest01 extends Sprite {
		
		private var _canvas:BitmapData;
		private var _circle:Sprite;
		private var _testimage:BitmapData;
		
		public function DrawTest01() {
			init();
		}
		
		private function init() {
			_circle = new Sprite();
			_circle.graphics.beginFill(0x0 , 1);
			_circle.graphics.drawCircle(0 , 0 , 20);
			_circle.graphics.endFill();
			
			var glowfilter:GlowFilter = new GlowFilter(0x0 , 1 , 32, 32 , 1 , 2 , false , false);
			_circle.filters = [glowfilter];
			
			_testimage = new TestImage(0 , 0);
			var bmpImage:Bitmap = new Bitmap(_testimage);
			bmpImage.cacheAsBitmap = true;
			addChild(bmpImage);
			
			_canvas = new BitmapData(stage.stageWidth , stage.stageHeight , true , 0x00FFFFFF );
			var bmpMask:Bitmap = new Bitmap(_canvas);
			bmpMask.cacheAsBitmap = true;
			addChild(bmpMask);
			
			bmpImage.mask = bmpMask;
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN , onMouseDownHandler ) ;
			stage.addEventListener(MouseEvent.MOUSE_UP , onMouseUpHandler ) ;
		}

		private function onMouseDownHandler(e:MouseEvent):void {
			stage.addEventListener(MouseEvent.MOUSE_MOVE , onMouseMoveHandler ) ;
		}
		
		private function onMouseUpHandler(e:MouseEvent):void {
			stage.removeEventListener(MouseEvent.MOUSE_MOVE , onMouseMoveHandler ) ;
		}
		
		private function onMouseMoveHandler(e:MouseEvent):void {
			_circle.x = stage.mouseX;
			_circle.y = stage.mouseY;
			
			var m:Matrix = new Matrix();
			m.tx = stage.mouseX;
			m.ty = stage.mouseY;
			
			_canvas.draw(_circle , m);
			e.updateAfterEvent();
		}

		
	}
	
}